// {wb_t@ĆCMicrochipЃIWĩwb_t@Ctimer.hCM҂Kvӏ𔲐Cat̂łD

#include <p33fj128mc802.h>


/* T1CON rbg` */

#define T1_ON               0xffff      /* Timer1 I */
#define T1_OFF              0x7fff      /* Timer1 It */

#define T1_IDLE_CON         0xdfff      /* Idle[hɂ Timer1 I */
#define T1_IDLE_STOP        0xffff      /* Idle[hɂ Timer1 It */


#define T1_GATE_ON          0xffff      /* OT1CK(12ԃs)HighԂNbNTcỹNbNJEgAbv邱ƂŌv */
#define T1_GATE_OFF         0xffbf      /* O͂HighԌvIt */

#define T1_PS_1_1           0xffcf      /* vXP[FFcy͊O͂ 1/1 */
#define T1_PS_1_8           0xffdf      /*           @@@@@@@@@@@@@1/8 */
#define T1_PS_1_64          0xffef      /*          @@@@@@@@@@@@@1/64 */
#define T1_PS_1_256         0xffff      /*                  @@@@@@@   1/256 */

#define T1_SYNC_EXT_ON      0xffff      /* NbNOT1CKƂƂCOSynch external clk input */
#define T1_SYNC_EXT_OFF     0xfffb      /* Do not synch external clk input */

#define T1_SOURCE_EXT       0xffff      /* NbNOT1CK(12ԃs)Ƃ */
#define T1_SOURCE_INT       0xfffd      /* NbNfoCXCXgNVNbNTcyƂ */


/* Timer1 荞ݐݒ */
#define T1_INT_PRIOR_7      0xffff      /* Dxō */
#define T1_INT_PRIOR_6      0xfffe      
#define T1_INT_PRIOR_5      0xfffd      
#define T1_INT_PRIOR_4      0xfffc      
#define T1_INT_PRIOR_3      0xfffb      
#define T1_INT_PRIOR_2      0xfffa      
#define T1_INT_PRIOR_1      0xfff9      /* DxŒ */
#define T1_INT_PRIOR_0      0xfff8      /* 荞ݕs */

#define T1_INT_ON           0xffff      /* 荞݉ */
#define T1_INT_OFF          0xfff7      /* 荞ݕs */

/* Timers 1荞ݐݒp}N*/
#define EnableIntT1                    _T1IE = 1
#define DisableIntT1                   _T1IE = 0
#define SetPriorityIntT1(priority)     _T1IP = priority


/* Timer1֐vg^Cvi錾j */
void ConfigIntTimer1(unsigned int a) __attribute__ ((section (".libperi")));



/* T2CON rbg` */

#define T2_ON               0xffff      /* Timer2 I */
#define T2_OFF              0x7fff      /* Timer2 It */

#define T2_IDLE_CON         0xdfff      /* Idle[hɂ Timer2 I */
#define T2_IDLE_STOP        0xffff      /* Idle[hɂ Timer2 It */


#define T2_GATE_ON          0xffff      /* OT1CK(12ԃs)HighԂNbNTcỹNbNJEgAbv邱ƂŌv */
#define T2_GATE_OFF         0xffbf      /* O͂HighԌvIt */

#define T2_PS_1_1           0xffcf      /* vXP[FFcy͊O͂ 1/1 */
#define T2_PS_1_8           0xffdf      /*           @@@@@@@@@@@@@1/8 */
#define T2_PS_1_64          0xffef      /*          @@@@@@@@@@@@@1/64 */
#define T2_PS_1_256         0xffff      /*                  @@@@@@@   1/256 */

#define T2_32BIT_MODE_ON    0xffff      /* ^C}2C3ɂ 32 rbg^C}\ */
#define T2_32BIT_MODE_OFF   0xfff7  

#define T2_SOURCE_EXT       0xffff      /* NbNOT1CK(12ԃs)Ƃ */
#define T2_SOURCE_INT       0xfffd      /* NbNfoCXCXgNVNbNTcyƂ */


/* Timer2 荞ݐݒ */
#define T2_INT_PRIOR_7      0xffff      /* Dxō */
#define T2_INT_PRIOR_6      0xfffe      
#define T2_INT_PRIOR_5      0xfffd      
#define T2_INT_PRIOR_4      0xfffc      
#define T2_INT_PRIOR_3      0xfffb      
#define T2_INT_PRIOR_2      0xfffa      
#define T2_INT_PRIOR_1      0xfff9      /* DxŒ */
#define T2_INT_PRIOR_0      0xfff8      /* 荞ݕs */

#define T2_INT_ON           0xffff      /* 荞݉ */
#define T2_INT_OFF          0xfff7      /* 荞ݕs */

/* Timers 2荞ݐݒp}N*/
#define EnableIntT2                    _T2IE = 1
#define DisableIntT2                   _T2IE = 0
#define SetPriorityIntT2(priority)     _T2IP = priority


/* Timer2֐vg^Cvi錾j */
void ConfigIntTimer2(unsigned int a) __attribute__ ((section (".libperi")));



/* T3CON rbg` */

#define T3_ON               0xffff      /* Timer3 I */
#define T3_OFF              0x7fff      /* Timer3 It */

#define T3_IDLE_CON         0xdfff      /* Idle[hɂ Timer3 I */
#define T3_IDLE_STOP        0xffff      /* Idle[hɂ Timer3 It */


#define T3_GATE_ON          0xffff      /* OT1CK(12ԃs)HighԂNbNTcỹNbNJEgAbv邱ƂŌv */
#define T3_GATE_OFF         0xffbf      /* O͂HighԌvIt */

#define T3_PS_1_1           0xffcf      /* vXP[FFcy͊O͂ 1/1 */
#define T3_PS_1_8           0xffdf      /*           @@@@@@@@@@@@@1/8 */
#define T3_PS_1_64          0xffef      /*          @@@@@@@@@@@@@1/64 */
#define T3_PS_1_256         0xffff      /*                  @@@@@@@   1/256 */

#define T3_SYNC_EXT_ON      0xffff      /* NbNOT1CKƂƂCOSynch external clk input */
#define T3_SYNC_EXT_OFF     0xfffb      /* Do not synch external clk input */

#define T3_SOURCE_EXT       0xffff      /* NbNOT1CK(12ԃs)Ƃ */
#define T3_SOURCE_INT       0xfffd      /* NbNfoCXCXgNVNbNTcyƂ */


/* Timer3 荞ݐݒ */
#define T3_INT_PRIOR_7      0xffff      /* Dxō */
#define T3_INT_PRIOR_6      0xfffe      
#define T3_INT_PRIOR_5      0xfffd      
#define T3_INT_PRIOR_4      0xfffc      
#define T3_INT_PRIOR_3      0xfffb      
#define T3_INT_PRIOR_2      0xfffa      
#define T3_INT_PRIOR_1      0xfff9      /* DxŒ */
#define T3_INT_PRIOR_0      0xfff8      /* 荞ݕs */

#define T3_INT_ON           0xffff      /* 荞݉ */
#define T3_INT_OFF          0xfff7      /* 荞ݕs */

/* Timers 3荞ݐݒp}N*/
#define EnableIntT3                    _T3IE = 1
#define DisableIntT3                   _T3IE = 0
#define SetPriorityIntT3(priority)     _T3IP = priority


/* Timer3֐vg^Cvi錾j */
void ConfigIntTimer3(unsigned int a) __attribute__ ((section (".libperi")));




/* T4CON rbg` */

#define T4_ON               0xffff      /* Timer4 I */
#define T4_OFF              0x7fff      /* Timer4 It */

#define T4_IDLE_CON         0xdfff      /* Idle[hɂ Timer4 I */
#define T4_IDLE_STOP        0xffff      /* Idle[hɂ Timer4 It */


#define T4_GATE_ON          0xffff      /* OT1CK(12ԃs)HighԂNbNTcỹNbNJEgAbv邱ƂŌv */
#define T4_GATE_OFF         0xffbf      /* O͂HighԌvIt */

#define T4_PS_1_1           0xffcf      /* vXP[FFcy͊O͂ 1/1 */
#define T4_PS_1_8           0xffdf      /*           @@@@@@@@@@@@@1/8 */
#define T4_PS_1_64          0xffef      /*          @@@@@@@@@@@@@1/64 */
#define T4_PS_1_256         0xffff      /*                  @@@@@@@   1/256 */

#define T4_SYNC_EXT_ON      0xffff      /* NbNOT1CKƂƂCOSynch external clk input */
#define T4_SYNC_EXT_OFF     0xfffb      /* Do not synch external clk input */

#define T4_SOURCE_EXT       0xffff      /* NbNOT1CK(12ԃs)Ƃ */
#define T4_SOURCE_INT       0xfffd      /* NbNfoCXCXgNVNbNTcyƂ */

#define T4_32BIT_MODE_ON    0xffff      /* Timer 4  Timer 5 Ȃ 32 bit TimerƂ */
#define T4_32BIT_MODE_OFF   0xfff7 

/* Timer4 荞ݐݒ */
#define T4_INT_PRIOR_7      0xffff      /* Dxō */
#define T4_INT_PRIOR_6      0xfffe      
#define T4_INT_PRIOR_5      0xfffd      
#define T4_INT_PRIOR_4      0xfffc      
#define T4_INT_PRIOR_3      0xfffb      
#define T4_INT_PRIOR_2      0xfffa      
#define T4_INT_PRIOR_1      0xfff9      /* DxŒ */
#define T4_INT_PRIOR_0      0xfff8      /* 荞ݕs */

#define T4_INT_ON           0xffff      /* 荞݉ */
#define T4_INT_OFF          0xfff7      /* 荞ݕs */

/* Timers 4荞ݐݒp}N*/
#define EnableIntT4                    _T4IE = 1
#define DisableIntT4                   _T4IE = 0
#define SetPriorityIntT4(priority)     _T4IP = priority


/* Timer4֐vg^Cvi錾j */
void ConfigIntTimer4(unsigned int a) __attribute__ ((section (".libperi")));
