#include <p33FJ128MC802.h>
#include ".\include\definition_of_constants.h"

void speed_detect(void);
void w_com_limiting(void);
signed long limiter(signed long a, signed long b);
void DAConv(unsigned int a, signed int b);

// DMA1荞ݏ֐(TMR3ɂgK  5CHXLADϊ  DMAf[^]I㊄荞݁j
// zero_crosšoCPR4̌CdwߒlCf[eB䌈
void __attribute__((interrupt, no_auto_psv)) _DMA1Interrupt(void)
{
    signed long     Vol_com;                                            // dwߒl	
    signed long     w_diff;                                             // ]
    unsigned int    v_det;                                              // [^̗UNd
    unsigned int    v_N_det;                                            // vNd
    unsigned int    udmode;                                             // 0: v_det PC1: v_det P

    extern unsigned int     i_mode;                                     // Co[^[h
    extern unsigned int     zero_cross_detected;                        // [NXotO@0: zero_crossO, 1: zero_cross 
    extern signed int       t_count_filtered;                           // ^C}2̃JEgl(tB^o)
    extern unsigned int     ADCBuffer[] __attribute__((space(dma)));	// DMAɂA/Dϊʂi[z̐錾
    extern signed long      w_com;                                      // ]wߒl
    extern signed long      w_det;                                      // ]ol
    extern signed long      Cw;                                         // ϕ萔
    extern signed long      Cwmax;                                      // ϕ萔l
    
//   	_LATA2 = 1; 	// 9ԃsI
  
        switch(i_mode)                                                  // ADCBUffer[1]: vu,  ADCBuffer[2]: vv, ADCBuffer[3]: vw
        {
            case 0: v_det = ADCBuffer[3]; break;                        // v_det = vw (PWM1H=PWM, PWM2L=1) 
            case 1: v_det = ADCBuffer[2]; break;                        // v_det = vv (PWM1H=PWM, PWM3L=1) 
            case 2: v_det = ADCBuffer[1]; break;                        // v_det = vu (PWM2H=PWM, PWM3L=1)             
            case 3: v_det = ADCBuffer[3]; break;                        // v_det = vw (PWM2H=PWM, PWM1L=1) 
            case 4: v_det = ADCBuffer[2]; break;                        // v_det = vv (PWM3H=PWM, PWM1L=1) 
            case 5: v_det = ADCBuffer[1]; break;                        // v_det = wu (PWM3H=PWM, PWM2L=1) 
        }
        v_N_det = ADCBuffer[4];                                         // vNol
        udmode = i_mode % 2;                                            // 0: case 0, 2. 4, 1: case 1, 3, 5
      
        if(zero_cross_detected == 0)                                    // Co[^[hXVzero-cross𖢌ôƂ
        {
            switch(udmode)
            {
                case 0:if(v_det <= v_N_det)                             // case 0, 2, 4łv_det͒PDv_detvNƈv_o
                        {
                        // ̃Co[^[hؑփ^C~Oݒ
                            PR4 = t_count_filtered/2;                   // PR4ݒ ̃Co[^[hXV܂ł̎Ԃݒ
                            TMR4 = 0;                                   // TMR4ZbgDPR4̒l܂ŃJEgAbvT4Interrupt()֐N@ Co[^[hXV
                        // ]olvZ
                            speed_detect();                             // t_countɃ[^]vZ
                            zero_cross_detected = 1;                    // zero_crossotO@ꂪ1ɂȂƁCCo[^̃[hĂэXV܂PR4̍XVȂD
                        }; break;
                case 1:if(v_det >= v_N_det)                             // case 1, 3, 5łv_det͒PDv_detvNƈv_o
                        {
                        // ̃Co[^[hؑփ^C~Oݒ
                            PR4 = t_count_filtered/2;                   // PR4ݒ ̃Co[^[hXV܂ł̎Ԃݒ
                            TMR4 = 0;                                   // TMR4ZbgDPR4̒l܂ŃJEgAbvT4Interrupt()֐N@ Co[^[hXV
                        // ]olvZ
                            speed_detect();                             // t_countɃ[^]vZ
                            zero_cross_detected = 1;                    // zero_crossotO@ꂪ1ɂȂƁCCo[^̃[hĂэXV܂PR4̍XVȂD
                        }
            }                   
        }
            
        // ]wߒlǂݏo
            w_com = (signed long)ADCBuffer[0];
            
            w_com_limiting();                               // w_com̍Œl̐ݒ
            
        // ]
            w_diff = w_com - w_det;
        
        // ]wߒlj^
            DAConv(w_com  << 2, 0x7000);                    // `lAI
       	// ]olj^
            DAConv(w_det << 2, 0xF000);                     // `lBI

        // dwߒl ϕvZ
            Vol_com = Kiw_num * (Cw + w_diff)/Kiw_denom;
        
        // dwߒl@ፀvZ
            Vol_com += Kpw * w_diff;
            // dwߒl~b^
                Vol_com = limiter(Vol_com, Volmax);

//                DAConv(Vol_com + PWMPeriod, 0xF000);                     // `lBI        

                // ϕ萔vZ
            Cw += w_diff;
            // ϕ~b^
                Cw = limiter(Cw, Cwmax);

        // f[eBݒ
            P1DC1 = Vol_com + PWMPeriod;
            P1DC2 = Vol_com + PWMPeriod;
            P1DC3 = Vol_com + PWMPeriod;
                    
//    _LATA2 = 0; 								// 9ԃs It
	_DMA1IF = 0;								//荞݃tONA
}