#include ".\include\dma802.h"
#include ".\include\definition_of_constants.h"

// DMAW[ݒ֐
void init_DMA1()
{
    extern unsigned int ADCBuffer[] __attribute__((space(dma)));	// DMAɂA/Dϊʂi[z̐錾

    // ADC1 to DMA1 Config
    unsigned int DMA1CON_set = DMA1_MODULE_ON       & DMA1_SIZE_WORD
                            & PERIPHERAL_TO_DMA1    & DMA1_INTERRUPT_BLOCK
                            & DMA1_NORMAL           & DMA1_REGISTER_POST_INCREMENT
                            & DMA1_CONTINUOUS;
    unsigned int DMA1REQ_set = 0b00001101;                          // `l 1 ADC1 SƂD
    unsigned int DMA1STA_set = __builtin_dmaoffset(ADCBuffer);      // DMA RAM primary Start Addres registerݒ 
    unsigned int DMA1PAD_set = (volatile unsigned int)&ADC1BUF0;
    unsigned int DMA1CNT_set = NUMSAMP -1;

    DMA1CON = DMA1CON_set;
    DMA1REQ = DMA1REQ_set;
    DMA1STA = DMA1STA_set;    
    DMA1PAD = DMA1PAD_set;
    DMA1CNT = DMA1CNT_set;

    unsigned int DMA1IntConfig =  DMA1_INT_PRI_3 & DMA1_INT_ENABLE;
    ConfigIntDMA802(DMA1IntConfig);
}


// DMAW[荞ݐݒ֐
void ConfigIntDMA802(unsigned int DMA1IntConfig)
{
    _DMA1IF = 0;                                //荞݃tONA
    _DMA1IP = DMA1IntConfig & 0x07;            // 荞ݗDxݒ
    _DMA1IE = (DMA1IntConfig & 0x4000)>>14;    // DMA RAMւ̃f[^]I㊄荞݉
}

