#include ".\include\pwm802.h"
#include ".\include\definition_of_constants.h"

// PWMW[ݒ֐ig쓮ݒj
void init_PWM(void)
{
    unsigned int P1TCON_set = PWM1_EN           & PWM1_IDLE_STOP 
                            & PWM1_OP_SCALE1    & PWM1_IPCLK_SCALE1 
                            & PWM1_MOD_UPDN;   	
    unsigned int PWM1CON1_set = PWM1_MOD3_COMP   & PWM1_MOD2_COMP 
                            & PWM1_MOD1_COMP     & PWM1_PEN3L 
                            & PWM1_PEN3H        & PWM1_PEN2L 
                            & PWM1_PEN2H		& PWM1_PEN1L 
                            & PWM1_PEN1H;
    unsigned int PWM1CON2_set = PWM1_SEVOPS1    & PWM1_OSYNC_PWM
                            & PWM1_UEN;
    unsigned int P1DTCON1_set = PWM_DTAPS1      & PWM1_DTA40;           // fbh^C = 40/vXP[l/40MHz = 40/1/40MHz = 1 usec
    unsigned int P1DTCON2_set = PWM1_DTS3A_UA   & PWM1_DTS3I_UA
                            & PWM1_DTS2A_UA     & PWM1_DTS2I_UA
                            & PWM1_DTS1A_UA     & PWM1_DTS1I_UA;
    
    P1TCON   = P1TCON_set;
    PWM1CON1 = PWM1CON1_set;
    PWM1CON2 = PWM1CON2_set;
    P1TPER   = PWMPeriod-1;
    P1SECMP  = 0;                // PWM1_SEVOPS1 CADϊP1TMR = P1SECMP = 0ƂȂ^C~OɎs   
    P1DTCON1 = P1DTCON1_set;
    P1DTCON2 = P1DTCON2_set;
    
    P1OVDCON = 0xFFFF;           // I[o[Chsgp
}


