// {wb_t@ĆCMicrochipЃIWĩwb_t@Cpwm.hCM҂Kvӏ𔲐Cat̂łD

#include <p33fj128mc802.h>


/* P1TCON rbg` */
#define PWM1_EN                  0xA0FF  /*PWMW[gp*/
#define PWM1_DIS                 0x20FF  /*PWMW[gps*/

#define PWM1_IDLE_STOP           0xA0FF  /*idle[hɂA/DW[It*/
#define PWM1_IDLE_CON            0x80FF  /*idle[hɂA/DW[I*/

#define PWM1_OP_SCALE1           0xA00F  /* P1TMR = 0ƂȂ^C~OɊ荞  */
#define PWM1_OP_SCALE2           0xA01F  /* P1TMR = 0ƂȂ2ڂ̃^C~OɊ荞  */
#define PWM1_OP_SCALE3           0xA02F  
#define PWM1_OP_SCALE4           0xA03F  
#define PWM1_OP_SCALE5           0xA04F  
#define PWM1_OP_SCALE6           0xA05F  
#define PWM1_OP_SCALE7           0xA06F  
#define PWM1_OP_SCALE8           0xA07F  
#define PWM1_OP_SCALE9           0xA08F  
#define PWM1_OP_SCALE10          0xA09F 
#define PWM1_OP_SCALE11          0xA0AF  
#define PWM1_OP_SCALE12          0xA0BF  
#define PWM1_OP_SCALE13          0xA0CF 
#define PWM1_OP_SCALE14          0xA0DF  
#define PWM1_OP_SCALE15          0xA0EF 
#define PWM1_OP_SCALE16          0xA0FF  /*@P1TMR = 0ƂȂ16ڂ̃^C~OɊ荞  */

#define PWM1_IPCLK_SCALE1        0xA0F3  /*PWM Time Base(PWMW[NbN)foCXCXgNVNbNFcyƂ */
#define PWM1_IPCLK_SCALE4        0xA0F7  /*PWM Time Base(PWMW[NbN)Fcy1^4Ƃ */
#define PWM1_IPCLK_SCALE16       0xA0FB  /*PWM Time Base(PWMW[NbN)Fcy1^16Ƃ */
#define PWM1_IPCLK_SCALE64       0xA0FF  /*PWM Time Base(PWMW[NbN)Fcy1^64Ƃ */

#define PWM1_MOD_FREE            0xA0FC  /*Free Runningîgj[h*/
#define PWM1_MOD_SING            0xA0FD  /*Single Eventîgj[hiPTEN = 1 ƂPWMg`1񂾂o͂āCPTEN = 0 ɃZbgĒ~j*/
#define PWM1_MOD_UPDN            0xA0FE  /*Up/Down CountiOpgj[h */
#define PWM1_MOD_DBL             0xA0FF  /*Up/Down CountiOpgj[hCP1TMR = 0  P1TMR = P1TPER̗Ŋ荞ݎs */


/* PWM1CON1 rbg` */
#define PWM1_MOD3_COMP           0x0BFF  /*PWM1H3PWM1L3complimentary modei⃂[hj*/
#define PWM1_MOD2_COMP           0x0DFF  /*PWM1H2PWM1L2complimentary modei⃂[hj*/
#define PWM1_MOD1_COMP           0x0EFF  /*PWM1H1PWM1L1complimentary modei⃂[hj*/


#define PWM1_MOD3_IND            0x0FFF  /*PWM1H3PWM1L3independent modeiƗ[hj*/
#define PWM1_MOD2_IND            0x0FFF  /*PWM1H2PWM1L2independent modeiƗ[hj*/
#define PWM1_MOD1_IND            0x0FFF  /*PWM1H1PWM1L1independent modeiƗ[hj*/


#define PWM1_PEN3H               0x0FFF  /*PWM1H3PWMo͂Ƃ*/
#define PWM1_PDIS3H              0x0FBF  /*PWM1H3IOpsƂ*/

#define PWM1_PEN2H               0x0FFF  /*PWM1H2PWMo͂Ƃ*/
#define PWM1_PDIS2H              0x0FDF  /*PWM1H2IOpsƂ*/

#define PWM1_PEN1H               0x0FFF  /*PWM1H1PWMo͂Ƃ*/
#define PWM1_PDIS1H              0x0FEF  /*PWM1H1IOpsƂ*/

#define PWM1_PEN3L               0x0FFF  /*PWM1L3PWMo͂Ƃ*/
#define PWM1_PDIS3L              0x0FFB  /*PWM1L3IOpsƂ*/

#define PWM1_PEN2L               0x0FFF  /*PWM1L2PWMo͂Ƃ*/
#define PWM1_PDIS2L              0x0FFD  /*PWM1L2IOpsƂ*/

#define PWM1_PEN1L               0x0FFF  /*PWM1L1PWMo͂Ƃ*/
#define PWM1_PDIS1L              0x0FFE  /*PWM1L1IOpsƂ*/


/* PWM1CON2 rbg` */
#define PWM1_SEVOPS1             0x0003  /*ADϊP1TMR = P1SECMPƂȂ^C~OɎs*/
#define PWM1_SEVOPS2             0x0103  /*ADϊP1TMR = P1SECMPƂȂ2ڂ̃^C~OɎs*/
#define PWM1_SEVOPS3             0x0203  
#define PWM1_SEVOPS4             0x0303  
#define PWM1_SEVOPS5             0x0403  
#define PWM1_SEVOPS6             0x0503  
#define PWM1_SEVOPS7             0x0603  
#define PWM1_SEVOPS8             0x0703  
#define PWM1_SEVOPS9             0x0803  
#define PWM1_SEVOPS10            0x0903  
#define PWM1_SEVOPS11            0x0A03  
#define PWM1_SEVOPS12            0x0B03  
#define PWM1_SEVOPS13            0x0C03  
#define PWM1_SEVOPS14            0x0D03  
#define PWM1_SEVOPS15            0x0E03  
#define PWM1_SEVOPS16            0x0F03  /* ADϊP1TMR = P1SECMPƂȂ16ڂ̃^C~OɎs*/


#define PWM1_OSYNC_PWM           0x0F03  /* P1OVDCONWX^̍XVPWM Time Baseɓ*/
#define PWM1_OSYNC_TCY           0x0F01  /* P1OVDCONWX^̍XVVXeNbNTcyɓ*/

#define PWM1_UDIS                0x0F03  /* P1DCsCPTPER XVs */
#define PWM1_UEN                 0x0F02  /* P1DCsCPTPER XV*/


/* P1DTCON1 rbg` */
#define PWM_DTBPS8              0xFFFF  // Unit B ̃vXP[l = 1/8
#define PWM_DTBPS4              0xBFFF  //                         = 1/4
#define PWM_DTBPS2              0x7FFF  //                         = 1/2
#define PWM_DTBPS1              0x3FFF  //                         = 1/1
                                                        
#define PWM_DTAPS8              0xFFFF  // Unit A ̃vXP[l = 1/8
#define PWM_DTAPS4              0xFFBF  //                         = 1/4
#define PWM_DTAPS2              0xFF7F  //                         = 1/2
#define PWM_DTAPS1              0xFF3F  //                         = 1/1


// DTAlݒ
#define PWM1_DTA0                0xFFC0  //Unit A ̃fbh^Cݒ  Deadtime = DTAx * vXP[l * Tcy = 0 Tcy
#define PWM1_DTA1                0xFFC1  //                                    = vXP[l * Tcy
#define PWM1_DTA2                0xFFC2  //                                    = vXP[l * 2Tcy
#define PWM1_DTA3                0xFFC3  
#define PWM1_DTA4                0xFFC4  
#define PWM1_DTA5                0xFFC5  
#define PWM1_DTA6                0xFFC6 
#define PWM1_DTA7                0xFFC7  
#define PWM1_DTA8                0xFFC8  
#define PWM1_DTA9                0xFFC9 
#define PWM1_DTA10               0xFFCA 
#define PWM1_DTA11               0xFFCB  
#define PWM1_DTA12               0xFFCC  
#define PWM1_DTA13               0xFFCD 
#define PWM1_DTA14               0xFFCE 
#define PWM1_DTA15               0xFFCF 
#define PWM1_DTA16               0xFFD0 
#define PWM1_DTA17               0xFFD1 
#define PWM1_DTA18               0xFFD2 
#define PWM1_DTA19               0xFFD3 
#define PWM1_DTA20               0xFFD4  
#define PWM1_DTA21               0xFFD5
#define PWM1_DTA22               0xFFD6
#define PWM1_DTA23               0xFFD7
#define PWM1_DTA24               0xFFD8
#define PWM1_DTA25               0xFFD9
#define PWM1_DTA26               0xFFDA  
#define PWM1_DTA27               0xFFDB
#define PWM1_DTA28               0xFFDC  
#define PWM1_DTA29               0xFFDD 
#define PWM1_DTA30               0xFFDE
#define PWM1_DTA31               0xFFDF 
#define PWM1_DTA32               0xFFE0 
#define PWM1_DTA33               0xFFE1  
#define PWM1_DTA34               0xFFE2  
#define PWM1_DTA35               0xFFE3  
#define PWM1_DTA36               0xFFE4  
#define PWM1_DTA37               0xFFE5  
#define PWM1_DTA38               0xFFE6 
#define PWM1_DTA39               0xFFE7 
#define PWM1_DTA40               0xFFE8 
#define PWM1_DTA41               0xFFE9  
#define PWM1_DTA42               0xFFEA 
#define PWM1_DTA43               0xFFEB  
#define PWM1_DTA44               0xFFEC  
#define PWM1_DTA45               0xFFED  
#define PWM1_DTA46               0xFFEE 
#define PWM1_DTA47               0xFFEF  
#define PWM1_DTA48               0xFFF0 
#define PWM1_DTA49               0xFFF1  
#define PWM1_DTA50               0xFFF2  
#define PWM1_DTA51               0xFFF3  
#define PWM1_DTA52               0xFFF4  
#define PWM1_DTA53               0xFFF5  
#define PWM1_DTA54               0xFFF6  
#define PWM1_DTA55               0xFFF7
#define PWM1_DTA56               0xFFF8 
#define PWM1_DTA57               0xFFF9 
#define PWM1_DTA58               0xFFFA  
#define PWM1_DTA59               0xFFFB  
#define PWM1_DTA60               0xFFFC  
#define PWM1_DTA61               0xFFFD  
#define PWM1_DTA62               0xFFFE  
#define PWM1_DTA63               0xFFFF  //                                    = vXP[l * 63Tcy

// DTBlݒ
#define PWM1_DTB0                0xC0FF  //Unit B ̃fbh^Cݒ  Deadtime = DTAx * vXP[l * Tcy = 0 Tcy
#define PWM1_DTB1                0xC1FF  //                                    = vXP[l * Tcy
#define PWM1_DTB2                0xC2FF  //                                    = vXP[l * 2Tcy
#define PWM1_DTB3                0xC3FF 
#define PWM1_DTB4                0xC4FF 
#define PWM1_DTB5                0xC5FF  
#define PWM1_DTB6                0xC6FF 
#define PWM1_DTB7                0xC7FF  
#define PWM1_DTB8                0xC8FF 
#define PWM1_DTB9                0xC9FF  
#define PWM1_DTB10               0xCAFF  
#define PWM1_DTB11               0xCBFF  
#define PWM1_DTB12               0xCCFF 
#define PWM1_DTB13               0xCDFF 
#define PWM1_DTB14               0xCEFF 
#define PWM1_DTB15               0xCFFF  
#define PWM1_DTB16               0xD0FF 
#define PWM1_DTB17               0xD1FF  
#define PWM1_DTB18               0xD2FF  
#define PWM1_DTB19               0xD3FF  
#define PWM1_DTB20               0xD4FF 
#define PWM1_DTB21               0xD5FF  
#define PWM1_DTB22               0xD6FF  
#define PWM1_DTB23               0xD7FF 
#define PWM1_DTB24               0xD8FF 
#define PWM1_DTB25               0xD9FF  
#define PWM1_DTB26               0xDAFF 
#define PWM1_DTB27               0xDBFF  
#define PWM1_DTB28               0xDCFF  
#define PWM1_DTB29               0xDDFF  
#define PWM1_DTB30               0xDEFF  
#define PWM1_DTB31               0xDFFF  
#define PWM1_DTB32               0xE0FF 
#define PWM1_DTB33               0xE1FF 
#define PWM1_DTB34               0xE2FF 
#define PWM1_DTB35               0xE3FF
#define PWM1_DTB36               0xE4FF
#define PWM1_DTB37               0xE5FF 
#define PWM1_DTB38               0xE6FF
#define PWM1_DTB39               0xE7FF 
#define PWM1_DTB40               0xE8FF
#define PWM1_DTB41               0xE9FF 
#define PWM1_DTB42               0xEAFF 
#define PWM1_DTB43               0xEBFF 
#define PWM1_DTB44               0xECFF
#define PWM1_DTB45               0xEDFF
#define PWM1_DTB46               0xEEFF 
#define PWM1_DTB47               0xEFFF 
#define PWM1_DTB48               0xF0FF 
#define PWM1_DTB49               0xF1FF 
#define PWM1_DTB50               0xF2FF 
#define PWM1_DTB51               0xF3FF
#define PWM1_DTB52               0xF4FF 
#define PWM1_DTB53               0xF5FF 
#define PWM1_DTB54               0xF6FF 
#define PWM1_DTB55               0xF7FF  
#define PWM1_DTB56               0xF8FF  
#define PWM1_DTB57               0xF9FF  
#define PWM1_DTB58               0xFAFF 
#define PWM1_DTB59               0xFBFF 
#define PWM1_DTB60               0xFCFF 
#define PWM1_DTB61               0xFDFF 
#define PWM1_DTB62               0xFEFF 
#define PWM1_DTB63               0xFFFF  //                                    = vXP[l * 63Tcy

/* P1DTCON2 rbg` */
#define PWM1_DTS3A_UA            0x00DF  //CH3 TrIt@@㑤TrĨfbh^C unit Aɂ茈*/
#define PWM1_DTS3I_UA            0x00EF  //CH3 㑤TrIt@@TrĨfbh^C unit Aɂ茈*/                                              
#define PWM1_DTS2A_UA            0x00F7  //CH2 TrIt@@㑤TrĨfbh^C unit Aɂ茈*/                                                 
#define PWM1_DTS2I_UA            0x00FB  //CH2 㑤TrIt@@TrĨfbh^C unit Aɂ茈*/  
#define PWM1_DTS1A_UA            0x00FD  //CH1 TrIt@@㑤TrĨfbh^C unit Aɂ茈*/
#define PWM1_DTS1I_UA            0x00FE  //CH1 㑤TrIt@@TrĨfbh^C unit Aɂ茈*/ 
#define PWM1_DTS3A_UB            0x00FF  //CH3 TrIt@@㑤TrĨfbh^C unit Bɂ茈*/
#define PWM1_DTS3I_UB            0x00FF  //CH3 㑤TrIt@@TrĨfbh^C unit Bɂ茈*/  
#define PWM1_DTS2A_UB            0x00FF  //CH2 TrIt@@㑤TrĨfbh^C unit Bɂ茈*/
#define PWM1_DTS2I_UB            0x00FF  //CH2 㑤TrIt@@TrĨfbh^C unit Bɂ茈*/ 
#define PWM1_DTS1A_UB            0x00FF  //CH1 TrIt@@㑤TrĨfbh^C unit Bɂ茈*/
#define PWM1_DTS1I_UB            0x00FF  //CH1 㑤TrIt@@TrĨfbh^C unit Bɂ茈*/ 


/* P1OVDCON rbg` */

#define PWM1_GEN_3H              0xFFFF  // PWM1H3  PWM䂳D
#define PWM1_GEN_2H              0xFFFF  // PWM1H2  PWM䂳D
#define PWM1_GEN_1H              0xFFFF  // PWM1H1  PWM䂳D
#define PWM1_GEN_3L              0xFFFF  // PWM1L3  PWM䂳D
#define PWM1_GEN_2L              0xFFFF  // PWM1L2  PWM䂳D
#define PWM1_GEN_1L              0xFFFF  // PWM1L1  PWM䂳D

#define PWM1_POUT_3H             0xDFFF  // PWM1H3  POUT3HrbgɂĐ䂳D
#define PWM1_POUT_3L             0xEFFF  // PWM1L3  POUT3HrbgɂĐ䂳D
#define PWM1_POUT_2H             0xF7FF  // PWM1H2  POUT3HrbgɂĐ䂳D
#define PWM1_POUT_2L             0xFBFF  // PWM1L2  POUT3HrbgɂĐ䂳D
#define PWM1_POUT_1H             0xFDFF  // PWM1H1  POUT3HrbgɂĐ䂳D
#define PWM1_POUT_1L             0xFEFF  // PWM1L1  POUT3HrbgɂĐ䂳D
 
#define PWM1_POUT3H_ACT          0xFFFF  // PWM1_POUT_3Hݒ̂ƂCPWM1H3 =1 
#define PWM1_POUT3H_INACT        0xFFDF  // PWM1_POUT_3Hݒ̂ƂCPWM1H3 =0
#define PWM1_POUT3L_ACT          0xFFFF  // PWM1_POUT_3Lݒ̂ƂCPWM1L3 =1
#define PWM1_POUT3L_INACT        0xFFEF  // PWM1_POUT_3Lݒ̂ƂCPWM1L3 =0

#define PWM1_POUT2H_ACT          0xFFFF  // PWM1_POUT_2Hݒ̂ƂCPWM1H2 =1 
#define PWM1_POUT2H_INACT        0xFFF7  // PWM1_POUT_2Hݒ̂ƂCPWM1H2 =0 
#define PWM1_POUT2L_ACT          0xFFFF  // PWM1_POUT_2Lݒ̂ƂCPWM1L2 =1
#define PWM1_POUT2L_INACT        0xFFFB  // PWM1_POUT_2Lݒ̂ƂCPWM123 =0

#define PWM1_POUT1H_ACT          0xFFFF  // PWM1_POUT_1Hݒ̂ƂCPWM1H1 =1
#define PWM1_POUT1H_INACT        0xFFFD  // PWM1_POUT_1Hݒ̂ƂCPWM1H1 =0
#define PWM1_POUT1L_ACT          0xFFFF  // PWM1_POUT_1Lݒ̂ƂCPWM1L1 =1
#define PWM1_POUT1L_INACT        0xFFFE  // PWM1_POUT_1Lݒ̂ƂCPWM1L1 =0



/* PWM荞݉^sݒ */

#define PWM1_INT_EN              0xFFFF  /*PWM荞݉*/
#define PWM1_INT_DIS             0xFFF7  /*PWM荞ݕs*/


/* Enable/Disable FaultA Interrupt */
// gp


/* Setting the priority of PWM interrupt */
#define PWM1_INT_PR0             0xFFF8  /*PWM荞ݕsgp*/
#define PWM1_INT_PR1             0xFFF9  /*Dx@Œ*/
#define PWM1_INT_PR2             0xFFFA  
#define PWM1_INT_PR3             0xFFFB  
#define PWM1_INT_PR4             0xFFFC 
#define PWM1_INT_PR5             0xFFFD 
#define PWM1_INT_PR6             0xFFFE 
#define PWM1_INT_PR7             0xFFFF  /*Dx@ō*/


/* Setting the priority of PWM FaultA interrupt */
// gp


/* P1FLTACON Register */
// gp


/* PWM荞݁@}N */
#define EnableIntMCPWM                          _PWM1IE = 1
#define DisableIntMCPWM                         _PWM1IE = 0
#define SetPriorityIntMCPWM(priority)           _PWM1IP = priority

#define EnableMCPWMIntFLTA                      _FLTA1IE = 1
#define DisableMCPWMIntFLTA                     _FLTA1IE = 0
#define SetPriorityMCPWMIntFLTA(priority)       _FLTA1IP = priority


/* PWM ֐vg^Cvi錾j */


