// {wb_t@ĆCMicrochipЃIWĩwb_t@Cqei.hCM҂Kvӏ𔲐Cat̂łD

#include <p33fj128mc802.h>


/* QEICON WX^@rbg` */

#define QEI_DIR_SEL_QEB             0xFFFF /* QEIM = 0b001(QEI_MODE_TIMER)̂ƂCB(QEB)͂ʒuJE^(POSxCNTWX^)̃JEgAbv^_E肷 */
#define QEI_DIR_SEL_CNTRL           0xFFFE /* QEIM = 0b001(QEI_MODE_TIMER)̂ƂCUPDNrbg(QEICON̑11rbgj̒lʒuJE^̃JEgAbv^_E肷 */

#define QEI_EXT_CLK                 0xFFFF /* QEIM = 0b001(QEI_MODE_TIMER)̂ƂCA(QEA)͂ONbNƂDiオGbW𗘗pj*/
#define QEI_INT_CLK                 0xFFFD /* QEIM = 0b001(QEI_MODE_TIMER)̂ƂCTcyI */

#define QEI_INDEX_RESET_ENABLE      0xFFFF /* INDX͂ʒuJE^ZbgD */
#define QEI_INDEX_RESET_DISABLE     0xFFFB /* INDX͂ʒuJE^ZbgȂD */

#define QEI_CLK_PRESCALE_1          0xFFE7 /* QEIW[^C}ƂĎgꍇ̃vXP[ 1:1 */
#define QEI_CLK_PRESCALE_8          0xFFEF 
#define QEI_CLK_PRESCALE_64         0xFFF7 
#define QEI_CLK_PRESCALE_256        0xFFFF /* vXP[ 1:256 */

#define QEI_GATED_ACC_ENABLE        0xFFFF /* QEIM = 0b001(QEI_MODE_TIMER)̂ƂCQEAHighԂNbNTcỹNbNJEgAbv邱ƂŌv */
#define QEI_GATED_ACC_DISABLE       0xFFDF /* QEAHighԌvIt */

#define QEI_LOGIC_CONTROL_IO        0xFFFF /* UPDNrbg̒lUPDNo͗psɏo͉ƂD */
#define QEI_NORMAL_IO               0xFFBF /* UPDNo͗psgpsƂCUPDNo͗pɊ蓖ĂsCʏI/OsƂD */

#define QEI_INPUTS_SWAP             0xFFFF /* A(QEA)B(QEB)ւD */
#define QEI_INPUTS_NOSWAP           0xFF7F /* A(QEA)B(QEB)ւȂD */

#define QEI_MODE_x4_MATCH           0xFFFF /* QEIW[𒼊pGR[_ƂĎgpDʒuJE^QEA, QEB̗オE4GbWŃJEgAbv^_E(x4 mode)DʒuJE^MAXCNTɈvƂZbgD */
#define QEI_MODE_x4_PULSE           0xFEFF /* QEIW[𒼊pGR[_ƂĎgpDʒuJE^QEA, QEB̗オE4GbWŃJEgAbv^_E(x4 mode)DʒuJE^INDX͂ɂ胊ZbgD */
#define QEI_MODE_x2_MATCH           0xFDFF /* QEIW[𒼊pGR[_ƂĎgpDʒuJE^QEA̗オE2GbWŃJEgAbv^_E(x2 mode)DʒuJE^MAXCNTɈvƂZbg */
#define QEI_MODE_x2_PULSE           0xFCFF /* QEIW[𒼊pGR[_ƂĎgpDʒuJE^QEA̗オE2GbWŃJEgAbv^_E(x2 mode)DʒuJE^INDX͂ɂ胊ZbgD */
#define QEI_MODE_TIMER              0xF9FF /* QEIW[16rbg^C}ƂĎgp */
#define QEI_MODE_OFF                0xF8FF /* QEI W[It */

#define QEI_UP_COUNT                0xFFFF /* ʒuJE^(POSxCNT)JEgAbv */
#define QEI_DOWN_COUNT              0xF7FF /* ʒuJE^JEg_E */

#define QEI_IDLE_STOP               0xFFFF /* Idle[hɂQEIW[@It  */
#define QEI_IDLE_CON                0xDFFF /* Idle[hɂQEIW[@I  */


/* DFLTCONWX^@rbg` */
#define QEI_QE_CLK_DIVIDE_1_1       0xFF8F /* QEA/QEBpfBW^tB^̃NbNTcy 1:1 ɕD */
#define QEI_QE_CLK_DIVIDE_1_2       0xFF9F 
#define QEI_QE_CLK_DIVIDE_1_4       0xFFAF 
#define QEI_QE_CLK_DIVIDE_1_16      0xFFBF 
#define QEI_QE_CLK_DIVIDE_1_32      0xFFCF 
#define QEI_QE_CLK_DIVIDE_1_64      0xFFDF 
#define QEI_QE_CLK_DIVIDE_1_128     0xFFEF 
#define QEI_QE_CLK_DIVIDE_1_256     0xFFFF /* QEA/QEBpfBW^tB^̃NbNTcy 1:256 ɕD */

#define QEI_QE_OUT_ENABLE           0xFFFF  /* QEA, QEB, INDX͂fBW^tB^ʂėp */
#define QEI_QE_OUT_DISABLE          0xFF7F  /* QEA, QEB, INDX͂fBW^tB^ʂɗp */

#define POS_CNT_ERR_INT_ENABLE      0xFFFF  /* ʒuJE^ɃG[ꍇ̊荞݉ */
#define POS_CNT_ERR_INT_DISABLE     0xFEFF  /* ʒuJE^ɃG[ꍇ̊荞ݕs */

// x4[ĥƂ
#define MATCH_INDEX_PHASEB_HIGH     0xFFFF  /* BHigĥƂINDX͂ƈʒuJE^Zbg*/
#define MATCH_INDEX_PHASEB_LOW      0xFBFF  /* BLoŵƂINDX͂ƈʒuJE^Zbg*/

#define MATCH_INDEX_PHASEA_HIGH     0xFFFF  /* AHigĥƂINDX͂ƈʒuJE^Zbg*/   
#define MATCH_INDEX_PHASEA_LOW      0xFDFF  /* ALoŵƂINDX͂ƈʒuJE^Zbg*/

// x2[ĥƂ
#define MATCH_INDEX_INPUT_PHASEB    0xFFFF  /* BI*/
#define MATCH_INDEX_INPUT_PHASEA    0xFBFF  /* AI*/

#define MATCH_INDEX_INPUT_HIGH      0xFFFF  /* BHigĥƂINDX͂ƈʒuJE^Zbg*/
#define MATCH_INDEX_INPUT_LOW       0xFDFF  /* BLoŵƂINDX͂ƈʒuJE^Zbg*/



