#include <p33fj128mc802.h>
#include ".\include\sindata.h"
#include ".\include\definition_of_constants.h"
#include <dsp.h>

void DAConv(unsigned int a, signed int b);
signed long limiter(signed long a, signed long b);

// DMA1荞ݏ֐(PWMɂgK  ADϊ  DMAf[^]I荞݁j
// dwߒlCf[eB䌈
void __attribute__((interrupt, no_auto_psv)) _DMA1Interrupt(void)
{
    signed long             w_diff;                             // ]
    signed long             i_diff;                             // d
    signed long             i_com;                              // dwߒl
    signed long             Vol_com;                            // dwߒl
    signed long             iu_det, iv_det, iw_det;             // dol
    signed long             i_q;                                // qdol
    signed long             vu_com, vv_com, vw_com;             // edwߒl
    signed int              rotor_position;                     //[^|WV  Encoder Pulse *2 ň
   	unsigned int            i_posu, i_posv, i_posw;

    extern signed long      Ci;                                     // ϕ萔
    extern signed long      Cv;                                     // ϕ萔
    extern signed long      Cimax;                                  // ϕ萔ől
    extern signed long      Cvmax;                                  // ϕ萔ől
    extern signed long      w_det;                                  // ]ol
    extern signed long      w_com;                                  // ]wߒl
    extern unsigned int     ADCBuffer[] __attribute__((space(dma)));	// DMAɂA/Dϊʂi[z̐錾
    
   	_LATA2 = 1; 	// 9ԃsI
  
    // ]wߒlǂݏo
        w_com = (signed long)ADCBuffer[1] - 512;

    // ]
        w_diff = w_com - w_det;
        
	// ]wߒlj^
        DAConv((w_com + 512) << 2, 0x7000);           // `lAI
        DAConv((w_det + 512) << 2, 0xF000);           // `lAI

    // dwߒl ϕvZ
        i_com = Kii_num * (Ci + w_diff) / Kii_denom;
        
    // dwߒl@ፀvZ
        i_com += Kpi * w_diff;
        // dwߒl~b^
            i_com = limiter(i_com, Volmax);
        
    // ϕ萔vZ
        Ci += w_diff;
        // ϕ~b^
            Ci = limiter(Ci, Cimax);

	//QEI z = 1̃JEgAbvl@
	rotor_position = POS1CNT;               //[^|WV
											// ]@@0 @2*Encoder Pulse No. ܂ŃJEgAbv@z͂ŃZbg
											// t]@@0 @- 2*Encoder Pulse No.  ܂ŃJEg_E@z͂ŃZbg        
		if(rotor_position < 0)
		{
 			rotor_position +=  sin_div;     // t]́@2*Encoder Puls No. @0 ւƃJEg_Eݒ
 		}
    
    rotor_position +=  sin_div_4_3;         // sidata̍쐬4pi/3ʑi܂Ă邽߁D
	 		
    // dol
        iu_det = (signed long)ADCBuffer[2] - 170;
        iv_det = (signed long)ADCBuffer[3] - 150;
        iw_det = -iu_det - iv_det;

//        DAConv((iu_det + 512) << 2, 0x7000);           // `lAI
//        DAConv((iw_det + 512) << 2, 0xF000);           // `lAI        
        
    // qdolvZ
		i_posu = rotor_position;
   		i_posv = rotor_position - sin_div_2_3;
        i_posw = rotor_position - sin_div_4_3;
        i_q = (iu_det * sindata[i_posu] + iv_det * sindata[i_posv] + iw_det *sindata[i_posw]) >> 15; 

	// ]wߒlj^
//        DAConv(((i_com >> 1) + 512) << 2, 0x7000);           // `lAI
//        DAConv(((i_q   >> 1) + 512) << 2, 0xF000);           // `lAI
        
        
    // d
        i_diff = i_com - i_q;       

//        DAConv(((i_diff   >> 1) + 512) << 2, 0xF000);           // `lAI        
        
    // dwߒl ϕvZ
        Vol_com = Kiv_num * (Cv + i_diff) / Kiv_denom;
        
    // dwߒl@ፀvZ
        Vol_com += Kpv * i_diff;
        
    // ϕ萔vZ
        Cv += i_diff;
        // ϕ~b^
            Cv = limiter(Cv, Cvmax);                
    
        // dlj^
//        DAConv((iu_det + 512) << 2, 0x7000);           // `lAI
//        DAConv((iu_com + 512) << 2, 0xF000);           // `lAI
        
    // dwߒlvZ
        vu_com = Vol_com * sindata[i_posu] >> 15;
		vv_com = Vol_com * sindata[i_posv] >> 15;
		vw_com = Vol_com * sindata[i_posw] >> 15;
         
        vu_com = limiter(vu_com, Volmax);
        vv_com = limiter(vv_com, Volmax);
        vw_com = limiter(vw_com, Volmax);

//        DAConv(((Vol_com >>1 )+ 2000),0x7000);
        
    // f[eBݒ
    P1DC1 = vu_com + PWMPeriod;
	P1DC2 = vv_com + PWMPeriod;
	P1DC3 = vw_com + PWMPeriod; 
    
    _LATA2 = 0; 								// 9ԃs It
	_DMA1IF = 0;								//荞݃tONA
}

