#include ".\include\atan_data.h"

signed long arctan(signed long a, signed long b)
{
    signed long         a_temp, b_temp;     // ꎞi[p
    signed long         i_theta;            // atanvZp
    signed long         theta;              // px

    if(a >= 0)
    {
        if(b >= 0)
        {
            if(a >= b)
            {
                i_theta = (b <<7)/a;
                theta = 256 + atan_data[i_theta];
            }else{
                i_theta = (a <<7)/b;                
                theta = 512 - atan_data[i_theta];
            }
        }else{
            b_temp = -b;
            if(a >= b_temp)
            {
                i_theta = (b_temp <<7)/a;
                theta = 256 - atan_data[i_theta];
            }else{
                i_theta = (a <<7)/b_temp;                
                theta = atan_data[i_theta];
            }
        }
    }else{
        a_temp = - a;
        if(b >= 0)
        {
            if(a_temp >= b)
            {
                i_theta = (b <<7)/a_temp;
                theta = 768 - atan_data[i_theta];
            }else{
                i_theta = (a_temp <<7)/b;                
                theta = 512 + atan_data[i_theta];
            }
        }else{
            b_temp = -b;
            if(a_temp >= b_temp)
            {
                i_theta = (b_temp <<7)/a_temp;
                theta = 768 + atan_data[i_theta];
            }else{
                i_theta = (a_temp <<7)/b_temp;                
                theta = 1024 - atan_data[i_theta];
            }
        }
    }
    return theta;
}