#include <p33fj128mc802.h>
#include ".\include\sindata.h"
#include <math.h>
#include <dsp.h>
#include ".\include\definition_of_constants.h"

void DAConv(unsigned int a, signed int b);
signed long limiter(signed long a, signed long b);
void observer(void);

// DMA1荞ݏ֐(PWMɂgK  ADϊ  DMAf[^]I荞݁j
// dwߒlCf[eB䌈
void __attribute__((interrupt, no_auto_psv)) _DMA1Interrupt(void)
{
    signed long             w_diff;                                     // ]
    signed long             i_com;                                      // dwߒl
    signed long             i_diff;                                     // d
    signed long             Vol_com;                                    // dwߒl
    signed long             iu_det, iv_det, iw_det;                     // dol
    signed long             i_q;                                        // qdol
    signed int              rotor_position;                             //[^ʒu  1024 ň
    unsigned int            i_posu, i_posv, i_posw;                     // edwߒlp[^ʒu
    
    extern signed long      iu, iv, iw;
    extern signed long      vu_com, vv_com, vw_com;                     // edwߒl    
    extern signed long      Ci;                                         // ϕ萔
    extern signed long      Cimax;                                      // ϕ萔ől
    extern fractional       w_com;                                      // ]wߒl
    signed long             w_com_temp;                                 // ]wߒlꎞi[p
    extern signed long      w_det;                                      // ]olij^pj
    extern fractional       ADCBuffer[] __attribute__((space(dma)));	// DMAɂA/Dϊʂi[z̐錾
    
    // IuU[o֘Aϐ
    extern signed long      theta_estd;                                 // [^ʒul
    signed long             theta_estd_temp;                            // [^ʒulꎞi[p
    extern signed long      w_estd;                                     // ]l
    signed long             w_estd_temp;                                // ]lꎞi[p
    
        
 	_LATA3 = 1; 	// 10ԃsI

// IuU[o
    observer();                                                         // IuU[o֐N

    
// ]wߒlǂݏo Œ菬_ݒ
    w_com = ADCBuffer[1];                                               // -512 -- 511 @-1 - 0.999ɊZĎ擾
    w_com_temp = w_com >> 6;                                            //@tŒ菬_(-1 - 0.999) t(-511 -- 511)ɕϊ
    w_estd_temp = w_estd >> 6;

        
// ]
    w_diff = w_com_temp - w_estd_temp; 
//       DAConv(((w_diff<<6)+0x8000)>>4, 0xF000);                       // ]`lBI
//    w_diff = w_com_temp - w_det;                                       // ]olɂ]sꍇDIuU[ỏ]͗pȂD
                
// dwߒl ϕvZ
    i_com = Kii_num * (Ci + w_diff)/Kii_denom;
    
// dwߒl@ፀvZ
    i_com += Kpi * w_diff;                   
    // dwߒl~b^
        i_com = limiter(i_com, Volmax);
        
// ϕ萔vZ
    Ci += w_diff;
    // ϕ~b^
        Ci = limiter(Ci, Cimax);

// [^ʒu@

//        rotor_position = POS1CNT;                                     // [^ʒuolpꍇDIuU[õ[^ʒul͗pȂD
//        DAConv(POS1CNT<<1, 0x7000);                              // [^ʒul`lBI
//        theta_estd_temp = sindata[rotor_position + sin_div_4_3];      // [^ʒu  sinisindat쐬4/3ʑi܂Ă邽߂̕␳j
//        DAConv(((theta_estd_temp)+0x8000)>>4, 0x7000);                // [^ʒu  `lAI

//        DAConv(((POS1CNT - theta_estd) << 2) + 2048, 0xF000);      // [^ʒu덷`lBI

        rotor_position = theta_estd;                                    // [^ʒul

        // t]␳ 
        if(rotor_position < 0)
		{
 			rotor_position +=  sin_div;                                 // t]́@1024 @0 ւƃJEg_Eݒ
 		}
    
        rotor_position +=  sin_div_4_3;                                 // sidata̍쐬4pi/3ʑi܂Ă邽߁D
    
//      theta_estd_temp = sindata[rotor_position];                        // [^ʒu  sinisindat쐬4/3ʑi܂Ă邽߂̕␳j
//      DAConv(((theta_estd_temp)+0x8000)>>4, 0xF000);                  // [^ʒu  sin
        
// dollvZ
    iu_det = (signed long)iu>>6;                                        // tŒ菬_(-1 - 0.999) t(-511 -- 511)ɕϊ
    iv_det = (signed long)iv>>6;
    iw_det = (signed long)iw>>6;
    
// qdolvZ
    i_posu = rotor_position;                                            // Uʒu
   	i_posv = rotor_position - sin_div_2_3;                              // Vʒu
    i_posw = rotor_position - sin_div_4_3;                              // Wʒu
    i_q = (iu_det * sindata[i_posu] + iv_det * sindata[i_posv] + iw_det * sindata[i_posw]) >> 15; 
                                                                        // qdol sindata[]͌Œ菬_ł̂łZ15rbgVtg
//        DAConv((i_com  + 512) << 1, 0x7000);                      // dwߒl`lAI
//        DAConv((i_q    + 512) << 2, 0xF000);                      // qdol`lBI
        
        
// dwߒlvZ
    i_diff = i_com - i_q;                                               // dvZ  
    Vol_com = Kpv * i_diff;                                             // dwߒlvZiᐧj
    // ~b^
        Vol_com = limiter(Vol_com, Volmax);

// edwߒlvZ        
    vu_com = Vol_com * sindata[i_posu] >> 15;                           // Udwߒl
    vv_com = Vol_com * sindata[i_posv] >> 15;                           // Vdwߒl
    vw_com = Vol_com * sindata[i_posw] >> 15;                           // Wdwߒl
        
// f[eBݒ
    P1DC1 = vu_com + PWMPeriod;
	P1DC2 = vv_com + PWMPeriod;
	P1DC3 = vw_com + PWMPeriod; 
    
    _LATA3 = 0; 								// 10ԃs It
	_DMA1IF = 0;								//荞݃tONA
}

