/************************************
ZTX
*************************************/
#include <p33fj128mc802.h>
#include <math.h>
#include <stdlib.h>
#include ".\include\declaration_of_variables.h"

// RtBM[Vݒ
_FBS(0xFFFF);
_FSS(0xFFFF);
_FGS(0xFFFF);
_FOSCSEL(FNOSC_FRCPLL);			// vC}IV[^ɓUq𗘗pCPLL𗘗pD
_FOSC(OSCIOFNC_ON);             // OSC2 (10ԃs) ʏI/Os@ƂD OFFƂƃNbN10ԃso͂D
_FWDT(FWDTEN_OFF);				// EHb`hbN^C}  SWDTEN rbgɂI/It@_SWDTEN = 0 ŃEHb`hbO^C}It
_FPOR(FPWRT_PWR128);            // Power-on Reset Timer 128ms
_FICD(JTAGEN_OFF & ICS_PGD3);	// JTAGItCICSPɂfobOp[qPGD3i14ԃsjɐݒ

void init_DMA1();
void init_SPI(void);
void init_ADC(void);
void init_PWM(void);
void init_timer2(void);
void init_timer3(void);
void init_timer4(void);
void start_position_setting(void);
void start_routine(void);
void restart_routine(void);


//C֐
int main(void) 
 {
    //PLLݒ
    _PLLPRE   =  0;     // N1 =  2
    _PLLDIV   = 42;     //  M = 44
    _PLLPOST  =  0;     // N2 = 2
                        // FOSC = FRC * M / (N1 * N2), FCY = Fosc / 2
                        // FOSC = 7.37 MHz * 44 / (2 * 2) = 81MHz,  FCY = 40.5MHz

    _SWDTEN = 0;                     //EHb`hbO^C}It
    while(OSCCONbits.LOCK !=1 );     // PLLbN҂
    
       
    // I/O |[gݒ
        TRISA = 	0x0003;                 // RA0, 1 ̓|[gݒ
        TRISB = 	0b0000000000000111;		// RB0-2 ̓|[gݒ
	
	// SPIp|[gݒ
        _RP8R =  8;                         //RP8  SCK (01000) Ɋ蓖
        _RP7R =  7;                         //RP7  SDO (00111)Ɋ蓖
    
    // ӃW[ݒ
        init_PWM();             // MCPWM ݒ
    
        start_position_setting();
    
        init_SPI();             // SPIݒ
        init_timer2();          // timer2ݒ(]vZp)
        init_DMA1();            // DMAݒ(荞ݗDxōC̊֐łzero_cross肪xolCCo[^[hXV^C~O̊ƂȂĂDj
                                // TMR2, TMR3͊荞݂ȂDTMR4zero_cross̔󂯂āCCo[^[hXV܂ł̎Ԃ肵ĂDTMR4̗DxDMA1ႢDj
        init_timer3();          // timer3ݒ(ADϊ̃TvOg 5CHXL20kHzŎsݒ)
        init_timer4();          // timer4ݒ(zero_crossCo[^[hXV܂ł̎Ԃ)   
        init_ADC();             // ADCݒ  (4CHXLTMR3ݒ̎Ŏs)          
    
	//[v
	while(1)
	{
        restart_routine();
	}
}

