/*********************************************
uVX[^ ghCu
**********************************************/
#include <p33fj128mc802.h>
#include ".\include\declaration_of_variables.h"

// RtBM[Vݒ
_FBS(0xFFFF);
_FSS(0xFFFF);
_FGS(0xFFFF);
_FOSCSEL(FNOSC_FRCPLL);			// vC}IV[^ɓUq𗘗pCPLL𗘗pD
_FOSC(OSCIOFNC_ON);             // OSC2 (10ԃs) ʏI/Os@ƂD OFFƂƃNbN10ԃso͂D
_FWDT(FWDTEN_OFF);				// EHb`hbN^C}  SWDTEN rbgɂI/It@_SWDTEN = 0 ŃEHb`hbO^C}It
_FPOR(FPWRT_PWR128);            // Power-on Reset Timer 128ms
_FICD(JTAGEN_OFF & ICS_PGD1);	// JTAGItCICSPɂfobOp[qPGD1i4ԃsjɐݒ

void init_DMA1(void);
void init_SPI(void);
void init_ADC(void);
void init_PWM(void);
void init_PWM1(void);
void init_QEI(void);
void init_IC(void);
void init_timer2(void);
void rotor_initial_position_setting();

//C֐
int main(void) 
 {
    //PLLݒ
    _PLLPRE   =  0;     // N1 =  2
    _PLLDIV   = 42;     //  M = 44
    _PLLPOST  =  0;     // N2 = 2
                        // FOSC = FRC * M / (N1 * N2), FCY = Fosc / 2
                        // FOSC = 7.37 MHz * 44 / (2 * 2) = 81MHz,  FCY = 40.5MHz

    _SWDTEN = 0;                     //EHb`hbO^C}It
    while(OSCCONbits.LOCK !=1 );     // PLLbN҂
        
    // I/O |[gݒ
        TRISA = 	0x0003;                 // RA0 , RA1-4 o̓|[gݒ
        TRISB = 	0b0000000000011111;		// RB2-4, 7-9 ̓|[gݒ
	
	// SPIp|[gݒ
        _RP8R =  8;                         //RP8  SCK (01000) Ɋ蓖
        _RP7R =  7;                         //RP7  SDO (00111)Ɋ蓖
    
   	// QEIp|[gݒ
        _QEA1R = 4;                         // QEA1R @RP4 Ɋ蓖
        _QEB1R = 3;                         // QEB1R @RP3 Ɋ蓖
        _INDX1R = 2;                        // INDX1R  RP2 Ɋ蓖

    //ICp|[gݒ
        _IC1R = 4;                          // IC1R  RP4 Ɋ蓖
    
    // ӃW[ݒ
        init_DMA1();            // DMAݒiADϊʂ̃f[^] & 荞  ]j@荞ݗDxŒ@x͑xĂ\ȂDx̌oD悳ׂD
        init_SPI();             // SPIݒ
        init_QEI();            	// QEIݒ
        init_timer2();          // TMR2ݒiCvbgLv`pj 荞ݗDxō@xoɂăI[o[t[oėD
        init_IC();              // ICݒixopj荞ݗDx2Ԗڂɍ@xoD
        init_PWM1();            // MCPWM ݒ(120ʓd쓮ݒ)
        AD1PCFGL = 0xFFFF;      // AN0-AN5(2-7ԃsfBW^̓|[gݒƂD[^ʒu߂ɂRB2(GR[_z)̒l(fBW^l)ǂݍނ߁D

    // [^ʒu
        rotor_initial_position_setting();   

    // ӃW[ݒiÂj
        init_PWM();             // MCPWM ݒig쓮ݒj
        init_ADC();             // ADCݒ            
        POS1CNT = 0;            // [^̏ʒu  POS1CNT = 0
        
	//C[v
	while(1)
	{
	}
}


