#include <p33fj128mc802.h>
#include <dsp.h>
#include ".\include\definition_of_constants.h"

void DAConv(unsigned int a, signed int b);
signed long limiter(signed long a, signed long b);

//^C}2I[o[t[荞ݏ֐
void __attribute__((interrupt, no_auto_psv)) _T2Interrupt(void) 
{	
    extern unsigned int tmr2_matchflag;     // Timer2 }b`tO
    
   	//_LATA2 = 1;                           // 9ԃs I
    
	tmr2_matchflag = 1;
    
   	//_LATA2 = 0;                           // 9ԃs It
	_T2IF = 0;                              // 荞݃tONA
}

// CvbgLv`荞ݏ֐@]olvZ
void __attribute__((interrupt, no_auto_psv)) _IC1Interrupt(void) 
{
    unsigned int            IC_count;           // ICɂ^C}2̃JEgl
    signed long             w_det_temp;
    
//    extern unsigned int	    IC_count_to_w_det;
    extern signed long      w_det;               // ]ol
    
    extern signed long      w_filter[];          // ړσtB^f[^oN
    extern signed long      w_sum;               // ړσtB^f[^oN̑a
    extern unsigned int     w_address;           // ړσtB^f[^oNւ̏ݔԒn
    extern unsigned int     tmr2_matchflag;     // Timer2 }b`tO
   	
//    _LATA3 = 1; 					// 10ԃsI@IC1InterruptNj^p
    
        TMR2 = 0;                   // timer2̃Zbg
    
        // CvbgLv`̃NbNǂݏo
            IC_count = IC1BUF + 1;

        //]olvZ
        	w_det_temp = (unsigned int)IC_count_to_w_det/IC_count;
            
        //]olړσtB^
            w_sum = w_sum - w_filter[w_address] + w_det_temp;
			w_filter[w_address++] = w_det_temp;
			w_address = w_address % w_indexmax;
            w_det = w_sum/w_indexmax;

        // w_det ㉺ݒ
            w_det = limiter(w_det, 511);	
            
        // Timer2}b``FbN
            if(tmr2_matchflag == 1)
            {
                w_det = 0;
                tmr2_matchflag = 0;
            }

        //[^]o@PF]COFt]
            if(_UPDN == 0)
            {
                w_det = -w_det;
            }
            
	// ]olj^
    //    DAConv((w_det + 512)<<2, 0xF000);      // `lBI
            
//	_LATA3 = 0;                             // 10ԃsIt@
	_IC1IF = 0;                             // 荞݃tONA
}